## libsdl3 3.2.10%2Bds

=== debian/control ===
Source: libsdl3
Priority: optional
Section: libs
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
Uploaders: Manuel A. Fernandez Montecelo <mafm@debian.org>,
           Felix Geyer <fgeyer@debian.org>,
           Simon McVittie <smcv@debian.org>
Standards-Version: 4.7.2
Build-Depends: cmake,
               debhelper-compat (= 13),
               fcitx-libs-dev,
               glslang-tools (>= 12),
               libasound2-dev [linux-any],
               libdbus-1-dev,
               libdecor-0-dev (>= 0.2.0) [linux-any],
               libdrm-dev [linux-any],
               libegl-dev [!hurd-any],
               libgbm-dev [linux-any],
               libgl-dev,
               libgles-dev [!hurd-any],
               libibus-1.0-dev,
               libpipewire-0.3-dev (>= 0.3.44) [linux-any],
               libpulse-dev,
               libsndio-dev,
               libudev-dev [linux-any],
               liburing-dev [linux-any],
               libusb2-dev [kfreebsd-any],
               libusbhid-dev [kfreebsd-any],
               libvulkan-dev [linux-any],
               libwayland-dev [linux-any],
               libx11-dev,
               libxcursor-dev,
               libxext-dev,
               libxfixes-dev,
               libxi-dev,
               libxinerama-dev,
               libxkbcommon-dev,
               libxrandr-dev,
               libxss-dev,
               libxt-dev,
               libxv-dev,
               libxxf86vm-dev,
               pkgconf,
               wayland-protocols,
               xxd
Build-Depends-Indep: doxygen <!nodoc>, graphviz <!nodoc>
Vcs-Git: https://salsa.debian.org/sdl-team/libsdl3.git
Vcs-Browser: https://salsa.debian.org/sdl-team/libsdl3
Homepage: https://www.libsdl.org/
Rules-Requires-Root: no

Package: libsdl3-0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends},
            libdbus-1-3,
            libegl1,
            libgl1 | libopengl0,
            libgles2,
            libudev1 [linux-any]
Suggests: libayatana-appindicator3-1 | libappindicator3-1,
          libpipewire-0.3-0t64 [linux-any],
          liburing2 [linux-any],
          libvulkan1,
          xdg-utils
Description: Simple DirectMedia Layer, version 3
 SDL is a cross-platform library designed to make it easy to write
 multimedia software such as games and emulators.
 .
 This package contains the shared library.

Package: libsdl3-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libasound2-dev [linux-any],
         libdbus-1-dev,
         libdecor-0-dev (>= 0.2.0) [linux-any],
         libdrm-dev [linux-any],
         libegl-dev [!hurd-any],
         libgbm-dev [linux-any],
         libgl-dev,
         libgles-dev [!hurd-any],
         libibus-1.0-dev,
         libpipewire-0.3-dev (>= 0.3.44) [linux-any],
         libpulse-dev,
         libsdl3-0 (= ${binary:Version}),
         libsndio-dev,
         libudev-dev [linux-any],
         libusb2-dev [kfreebsd-any],
         libusbhid-dev [kfreebsd-any],
         libwayland-dev [linux-any],
         libx11-dev,
         libxcursor-dev,
         libxext-dev,
         libxfixes-dev,
         libxi-dev,
         libxinerama-dev,
         libxkbcommon-dev,
         libxrandr-dev,
         libxss-dev,
         libxt-dev,
         libxv-dev,
         libxxf86vm-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Simple DirectMedia Layer, version 3 development files
 SDL is a cross-platform library designed to make it easy to write
 multimedia software such as games and emulators.
 .
 This package contains the files needed to compile and link programs which
 use SDL.

Package: libsdl3-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends: ${misc:Depends}
Breaks: libsdl1.2-dev (<< 1.2.64)
Replaces: libsdl1.2-dev (<< 1.2.64)
Description: Reference manual for SDL 3
 SDL is a cross-platform library designed to make it easy to write
 multimedia software such as games and emulators.
 .
 This package contains the reference manual and examples.

Package: libsdl3-tests
Section: misc
Architecture: any
Build-Profiles: <!noinsttest>
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: gnome-desktop-testing
Description: Simple DirectMedia Layer automated and manual tests
 SDL is a cross-platform library designed to make it easy to write
 multimedia software such as games and emulators.
 .
 This package contains manual and automated tests. The automated tests can
 be run using ginsttest-runner in the gnome-desktop-testing package,
 or manually.

=== debian/tests/control ===
Tests: build
Depends: build-essential, clang:native, libsdl3-dev, pkgconf
Restrictions: superficial, allow-stderr

Tests: cmake
Depends: build-essential, cmake, libsdl3-dev, pkgconf
Restrictions: superficial, allow-stderr

Tests: flaky
Depends: libsdl3-tests
Restrictions: allow-stderr, flaky, superficial

Tests: installed-tests
Depends: gnome-desktop-testing, libsdl3-tests
Restrictions: allow-stderr

## libsdl3 3.2.10+ds

=== src/hidapi/linux/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6.3...3.25 FATAL_ERROR)

add_library(hidapi_hidraw
    ${HIDAPI_PUBLIC_HEADERS}
    hid.c
)
target_link_libraries(hidapi_hidraw PUBLIC hidapi_include)

find_package(Threads REQUIRED)

include(FindPkgConfig)
pkg_check_modules(libudev REQUIRED IMPORTED_TARGET libudev)

target_link_libraries(hidapi_hidraw PRIVATE PkgConfig::libudev Threads::Threads)

set_target_properties(hidapi_hidraw
    PROPERTIES
        EXPORT_NAME "hidraw"
        OUTPUT_NAME "hidapi-hidraw"
        VERSION ${PROJECT_VERSION}
        SOVERSION ${PROJECT_VERSION_MAJOR}
        PUBLIC_HEADER "${HIDAPI_PUBLIC_HEADERS}"
)

# compatibility with find_package()
add_library(hidapi::hidraw ALIAS hidapi_hidraw)
# compatibility with raw library link
add_library(hidapi-hidraw ALIAS hidapi_hidraw)

if(HIDAPI_INSTALL_TARGETS)
    install(TARGETS hidapi_hidraw EXPORT hidapi
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/hidapi"
    )
endif()

hidapi_configure_pc("${PROJECT_ROOT}/pc/hidapi-hidraw.pc.in")

=== debian/changelog ===
libsdl3 (3.2.10+ds-1) unstable; urgency=medium

  * New upstream stable release
  * d/patches: Add post-release bug fixes from upstream release-3.2.x
    branch, up to commit release-3.2.10-6-g0759f22a91, excluding
    N3DS-specific changes that are not relevant on Linux
    - Fix Vulkan vertex buffer indexing
    - Fix texture colour space when creating a texture from a surface
    - Documentation improvements for high DPI

 -- Simon McVittie <smcv@debian.org>  Tue, 01 Apr 2025 14:43:02 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

built_binaries := $(shell dh_listpackages)

include /usr/share/dpkg/default.mk

export SDL_AUDIO_DRIVER=dummy
export SDL_VIDEO_DRIVER=dummy

# Upstream test timeouts assume a gaming-capable system.
# Keep the timeout reasonably short for architectures where interactive
# debugging is more likely, but extend it a lot on architectures that might
# be very slow or using qemu for buildds.
ifneq ($(filter amd64 i386,$(DEB_HOST_ARCH_CPU)),)
test_timeout_multiplier = 3
else
test_timeout_multiplier = 20
endif

confflags = \
	-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
	-DSDL_ALSA_SHARED=OFF \
	-DSDL_DEPS_SHARED=OFF \
	-DSDL_EXAMPLES=ON \
	-DSDL_HIDAPI_LIBUSB_SHARED=OFF \
	-DSDL_JACK=OFF \
	-DSDL_JACK_SHARED=OFF \
	-DSDL_KMSDRM_SHARED=OFF \
	-DSDL_OSS=OFF \
	-DSDL_PIPEWIRE_SHARED=ON \
	-DSDL_PULSEAUDIO_SHARED=OFF \
	-DSDL_RPATH=OFF \
	-DSDL_RPI=OFF \
	-DSDL_SHARED=ON \
	-DSDL_SNDIO_SHARED=ON \
	-DSDL_STATIC=ON \
	-DSDL_STATIC_PIC=ON \
	-DSDL_TESTS=ON \
	-DSDL_TESTS_TIMEOUT_MULTIPLIER=$(test_timeout_multiplier) \
	-DSDL_TEST_LIBRARY=ON \
	-DSDL_VENDOR_INFO="${DEB_VENDOR} ${DEB_VERSION}" \
	-DSDL_VIVANTE=OFF \
	-DSDL_X11=ON \
	-DSDL_X11_SHARED=OFF \
	-DSDLTEST_TIMEOUT_MULTIPLIER=$(test_timeout_multiplier) \
	$(NULL)

ifneq ($(filter %-tests,$(built_binaries)),)
  confflags += -DSDL_INSTALL_EXAMPLES=ON
  confflags += -DSDL_INSTALL_TESTS=ON
endif

ifeq ($(filter %-doc,$(built_binaries)),)
  confflags += -DSDL_INSTALL_DOCS=OFF
else
  confflags += -DSDL_INSTALL_DOCS=ON
endif

ifeq ($(DEB_HOST_ARCH_CPU),powerpc)
  confflags += -DSDL_ALTIVEC=OFF
endif

ifeq ($(DEB_HOST_ARCH_CPU),ppc64el)
  confflags += -DSDL_ALTIVEC=OFF
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
  confflags += -DSDL_WAYLAND=ON
  confflags += -DSDL_WAYLAND_LIBDECOR_SHARED=OFF
  confflags += -DSDL_WAYLAND_SHARED=OFF
else
  confflags += -DSDL_WAYLAND=OFF
endif

#ifeq ($(DEB_VERSION_UPSTREAM),3.1.6+git20250107+ds)
#  confflags += -DSDL_REVISION=preview-3.1.6-639-g0176a19aee
#endif

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	set -e; for bmp in test/icon.bmp test/gamepad_*.bmp test/glass.bmp; do \
		python3 cmake/xxd.py -i "$${bmp}" -o "$${bmp%.bmp}.h"; \
	done
	cd build-scripts && ./makecasefoldhashtable.pl > ../src/stdlib/SDL_casefolding.h
	cd src/render/gpu/shaders && LC_ALL=C bash -ex ./build-shaders.sh
	# This is intended as a Windows batch file, but at the time of writing
	# it's so simple that it's also a valid shell script
	cd src/render/vulkan && sh -ex ./compile_shaders.bat
	cd test/testgpu && OSTYPE=$(DEB_HOST_ARCH_OS) bash -ex ./build-shaders.sh
	cp debian/placeholders/testgpu_*.h test/testgpu/
	dh_auto_configure -- $(confflags)

execute_after_dh_auto_build:
ifneq ($(filter %-doc,$(built_binaries)),)
	sed -e 's/FULL_PATH_NAMES *=.*/FULL_PATH_NAMES = NO/' < docs/doxyfile > debian/Doxyfile
	cd docs && doxygen ../debian/Doxyfile
	# useless files
	find docs/output -name "*.md5" -delete
	find docs/output -type d -empty -delete
endif

# Only run testtimer as an autopkgtest on machines that we're reasonably
# sure are both fast and set up to be usable for interactive use
# (currently only x86 and 64-bit ARM).
# There is an assertion that requesting a 1ms delay does not result in
# a delay of more than 100ms, and that's not going to be reliably true
# on slow machines like riscv64 or batch-processing-oriented machines
# like s390x.
ifeq (,$(filter amd64 arm64 i386,$(DEB_HOST_ARCH)))
execute_after_dh_auto_install:
	rm -fv debian/tmp/usr/share/installed-tests/SDL3/testtimer.test
endif

execute_after_dh_auto_clean-indep:
	rm -f debian/Doxyfile
	rm -rf docs/output

# debhelper >= 13.4 makes all of /usr/libexec executable, which is not
# quite right for installed-tests
override_dh_fixperms:
	dh_fixperms -Xusr/libexec/installed-examples -Xusr/libexec/installed-tests
ifneq ($(filter %-tests,$(built_binaries)),)
	chmod --recursive --changes a+rX,u+w,og-w debian/libsdl3-tests/usr/libexec/installed-examples
	chmod --recursive --changes a+rX,u+w,og-w debian/libsdl3-tests/usr/libexec/installed-tests
endif

override_dh_installchangelogs:
	dh_installchangelogs -- WhatsNew.txt

=== debian/watch ===
version=4
# Upstream releases official source tarballs, so we use
# those in preference to git tags
opts="\
    compression=xz, \
    dversionmangle=s/[+~](?:ds|dfsg)[0-9]*$//;s/\+(?:git)?[0-9]+(?:\+g[0-9a-f]*)?$//, \
    downloadurlmangle=s#/tag/#/download/#;s#((?:prerelease|preview|release)-?@ANY_VERSION@)$#$1/SDL3-$2.tar.gz#, \
    filenamemangle=s#(?:prerelease|preview|release)-?@ANY_VERSION@#SDL3-$1.tar.gz#, \
    pgpmode=none, \
    repack, \
    repacksuffix=+ds" \
https://github.com/libsdl-org/SDL/tags .*/releases/tag/(?:release)-?@ANY_VERSION@

## libsdl3 3.2.18+ds

=== debian/changelog ===
libsdl3 (3.2.18+ds-1) experimental; urgency=medium

  * New upstream stable release
    - Add support for popups that can extend outside the display bounds or
      avoid grabbing focus
    - Don't let automatically generated gamepad mappings override
      manually-set mappings
    - Game controller support for ZEROPLUS P4 Wired Gamepad
    - Fix compatibility with MayFlash GameCube adapter with
      version 7 firmware
    - Read gyro and accelerometer calibration data from Switch controllers
      instead of using a hard-coded default
    - Fix a long delay when enumerating HIDAPI devices if a Razer Huntsman
      Gaming keyboard is attached
    - Don't allow setting a window to be its own parent
    - Add F21-F24 to the keyboard scancode mapping table
    - Fix a crash in SDL_GetAudioDeviceChannelMap() if a device has no
      channels
    - Skip "zombie" devices when enumerating audio devices
    - Update the rendering viewport when logical presentation changes
    - Avoid duplicate mouse events when using a pen device
    - Improve compatibility with XMonad
    - Improve compatibility with fvwm
    - Improve Wayland spec compliance
    - Ensure Vulkan non-dispatchable handles are 64-bit on x32
    - Documentation fixes
    - Fix some compiler warnings
    - Silence some debug spam by default
    - Make tests compatible with ffmpeg 7.1
      (not relevant in Debian, we don't compile this test)
    - Android-, macOS-, MSVC-, PSP-, Windows- and XBox-specific changes
      not relevant to Debian

 -- Simon McVittie <smcv@debian.org>  Sat, 19 Jul 2025 10:20:05 +0100

libsdl3 (3.2.16+ds-1) experimental; urgency=medium

  * New upstream stable release
    - When a compute shader writes to a texture, check that the format is a
      valid one for this purpose
    - Improve assertions in the GPU code
    - Fix Gamecube controller adapter hotplug detection
    - Fix Wayland event timestamps
    - Fix a rare crash while trying to interrupt SDL_WaitEvent()
    - Correctly mark the combined controller representing a pair of
      Switch Joy-Cons as a Bluetooth device, not USB
    - Fix a crash caused by incorrect reference counting of GTK menus when
      using the tray API
    - Fix an assertion failure on shutdown if a gamepad can't be opened
    - Correctly include XTest header
    - Set the initial axis values for HIDAPI controllers
    - When recording audio from PulseAudio, improve compatibility with
      drivers that can't keep up with small fragment sizes
    - Set minimum audio bit depth, rate and channel count to CD-quality,
      avoiding playback issues with devices that have problematically high
      defaults
    - On native X11 (but not Xwayland), always send fullscreen dimensions.
      Previously this was only done for Openbox, but other non-compositing
      window managers need this.
    - On X11, work around some window managers not sending an event when a
      window is shown
    - On X11, don't crash if libXi wasn't loaded successfully
    - On Wayland, make input method dialogs appear in the correct position
    - On Wayland, improve timestamp handling for keyboard repeats
    - On Wayland, fix copying of repeated keyboard input
    - On Steam Deck, tell Steam's on-screen keyboard the location of
      text input
    - On KMS/DRM, if surface creation fails, try again without scanout
      flags, as is necessary on Nvidia GPUs
    - Documentation fixes
    - 3DS-, Android-, Emscripten-, macOS-, PS2-, PSP-, Vita-, Windows-
      and XBox-specific changes not relevant to Debian
  * Add more details of the previous upstream stable release to its changelog
    entry

 -- Simon McVittie <smcv@debian.org>  Tue, 03 Jun 2025 12:47:12 +0100

libsdl3 (3.2.14+ds-1) experimental; urgency=medium

  * New upstream stable release
    - Fix rendering regressions in 3.2.12 caused by overzealous PulseAudio
      TLS cleanup
    - Avoid incorrect assertions in the GPU code when generating mipmaps
    - Use getauxval() to check for Altivec on PowerPC
    - Avoid unused function warnings in cpuinfo
    - Fix a crash when querying the name of a logical audio device
    - Fix a crash if the Vulkan renderer runs out of memory
    - On X11, improve Xinput mouse tracking
    - On X11, fix regressions in keyboard event handling
    - On X11, use a different workaround for Openbox quirks
    - Fix build if virtual joystick support is disabled
      (not relevant in Debian)
    - Fix build if Xrandr is disabled (not relevant in Debian)
    - Improve generated manual pages
    - Android-, Emscripten-, macOS, Vita-, Windows-specific changes not
      relevant to Debian

 -- Simon McVittie <smcv@debian.org>  Wed, 14 May 2025 19:33:36 +0100

libsdl3 (3.2.14~git20250513+ds-1) experimental; urgency=medium

  * d/watch, d/watch.git: Monitor the release-3.2.x branch for now
  * New upstream snapshot from the release-3.2.x branch
    (a preview of what is likely to be in 3.2.14, fixing regressions
    in 3.2.12)

 -- Simon McVittie <smcv@debian.org>  Wed, 14 May 2025 12:36:01 +0100

libsdl3 (3.2.12+ds-1) experimental; urgency=medium

  * New upstream stable release
    - Provide scroll wheel information in a form that is more useful for
      sdl2-compat
    - Avoid a deadlock in some SDL2 applications with sdl2-compat by
      reducing lock contention
    - Try to use the app name or app ID for audio stream names when using
      Pipewire for audio
    - Avoid thread-local data leaks when using PulseAudio for audio
    - Give the "HORI HORl Taiko No Tatsujin Drum Controller" a better name,
      despite the typo
    - Documentation fixes
    - Changes specific to Android, macOS and Windows not documented here
  * Drop patches, applied upstream
  * Initially upload to experimental, due to imminent hard freeze for
    Debian 13

 -- Simon McVittie <smcv@debian.org>  Tue, 06 May 2025 19:30:38 +0100

## libsdl3 3.2.20%2Bds

=== test/CMakeLists.txt ===
#
# CMake script for building the SDL tests
#

cmake_minimum_required(VERSION 3.16)

set(SDL3_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/..")

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/../cmake")

include(CheckIncludeFile)
include(CheckStructHasMember)
include(CMakePushCheckState)
include(sdlcompilers)

find_package(Python3 COMPONENTS Interpreter)
if(NOT PYTHON3_EXECUTABLE)
    set(PYTHON3_EXECUTABLE "python3")
endif()

if(SDL_TESTS_LINK_SHARED)
    set(sdl_name_component SDL3-shared)
else()
    set(sdl_name_component SDL3-static)
endif()
set(HAVE_TESTS_LINK_SHARED "${SDL_TESTS_LINK_SHARED}" PARENT_SCOPE)

# CMake incorrectly detects opengl32.lib being present on MSVC ARM64
if(NOT (MSVC AND SDL_CPU_ARM64))
    # Prefer GLVND, if present
    set(OpenGL_GL_PREFERENCE GLVND)
    find_package(OpenGL)
endif()

set(SDL_TEST_EXECUTABLES)

add_library(sdltests_utils OBJECT
    testutils.c
)
target_link_libraries(sdltests_utils PRIVATE SDL3::Headers)

file(GLOB RESOURCE_FILES *.bmp *.wav *.hex moose.dat utf8.txt)

option(SDLTEST_TRACKMEM "Run tests with --trackmem" OFF)

if(WIN32)
    option(SDLTEST_PROCDUMP "Run tests using sdlprocdump for minidump generation" OFF)
    add_executable(sdlprocdump win32/sdlprocdump.c)
    set_property(TARGET sdlprocdump PROPERTY C_STANDARD "90")
    SDL_AddCommonCompilerFlags(sdlprocdump)
    if(SDLTEST_PROCDUMP)
        set(CMAKE_TEST_LAUNCHER "$<TARGET_FILE:sdlprocdump>;--")
    else()
        set_property(TARGET sdlprocdump PROPERTY EXCLUDE_FROM_ALL "1")
    endif()
endif()

if(EMSCRIPTEN)
    set(SDLTEST_BROWSER "firefox" CACHE STRING "Browser in which to run SDL unit tests (chrome or firefox)")
    set(SDLTEST_PORT "8080" CACHE STRING "Port on which to serve the tests")
    set(SDLTEST_CHROME_BINARY "" CACHE STRING "Chrome/Chromium browser binary (optional)")
    if(TARGET Python3::Interpreter)
        add_custom_target(serve-sdl-tests
                COMMAND Python3::Interpreter "${CMAKE_CURRENT_SOURCE_DIR}/emscripten/server.py"
                "${SDLTEST_PORT}"
                -d "${CMAKE_CURRENT_BINARY_DIR}"
                --map "${SDL3_SOURCE_DIR}:/SDL")
    endif()
endif()

if(CMAKE_RUNTIME_OUTPUT_DIRECTORY)
    set(test_bin_dir "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")
    if(NOT IS_ABSOLUTE "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")
        set(test_bin_dir "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")
    endif()
else()
    set(test_bin_dir "${CMAKE_CURRENT_BINARY_DIR}")
endif()
if(NOT CMAKE_VERSION VERSION_LESS 3.20)
    get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
    set(test_bin_dir "${test_bin_dir}$<$<BOOL:${is_multi_config}>:/$<CONFIG>>")
endif()

set(RESOURCE_FILE_NAMES)
set(RESOURCE_FILES_BINDIR)
foreach(resource_file IN LISTS RESOURCE_FILES)
    get_filename_component(res_file_name ${resource_file} NAME)
    list(APPEND RESOURCE_FILE_NAMES "${res_file_name}")
    set(resource_file_bindir "${test_bin_dir}/${res_file_name}")
    add_custom_command(OUTPUT "${resource_file_bindir}"
        COMMAND "${CMAKE_COMMAND}" -E copy "${resource_file}" "${resource_file_bindir}"
        DEPENDS "${resource_file}"
    )
    list(APPEND RESOURCE_FILES_BINDIR "${resource_file_bindir}")
endforeach()
add_custom_target(copy-sdl-test-resources
    DEPENDS "${RESOURCE_FILES_BINDIR}"
)

define_property(TARGET PROPERTY SDL_NONINTERACTIVE BRIEF_DOCS "If true, target is a non-interactive test executable." FULL_DOCS "If true, target is a noninteractive test executable.")
define_property(TARGET PROPERTY SDL_NONINTERACTIVE_ARGUMENTS BRIEF_DOCS "Argument(s) to run executable in non-interactive mode." FULL_DOCS "Argument(s) to run executable in non-interactive mode.")
define_property(TARGET PROPERTY SDL_NONINTERACTIVE_TIMEOUT BRIEF_DOCS "Timeout for noninteractive executable." FULL_DOCS "Timeout for noninteractive executable.")

macro(add_sdl_test_executable TARGET)
    cmake_parse_arguments(AST "BUILD_DEPENDENT;NONINTERACTIVE;NEEDS_RESOURCES;TESTUTILS;THREADS;NO_C90;MAIN_CALLBACKS;NOTRACKMEM" "" "DEPENDS;DISABLE_THREADS_ARGS;NONINTERACTIVE_TIMEOUT;NONINTERACTIVE_ARGS;INSTALLED_ARGS;SOURCES" ${ARGN})
    if(AST_UNPARSED_ARGUMENTS)
        message(FATAL_ERROR "Unknown argument(s): ${AST_UNPARSED_ARGUMENTS}")
    endif()
    if(NOT AST_SOURCES)
        message(FATAL_ERROR "add_sdl_test_executable needs at least one source")
    endif()
    if(AST_TESTUTILS)
        list(APPEND AST_SOURCES $<TARGET_OBJECTS:sdltests_utils>)
    endif()
    set(EXTRA_SOURCES "")
    if(AST_NEEDS_RESOURCES)
        list(APPEND EXTRA_SOURCES ${RESOURCE_FILES})
    endif()
    if(ANDROID)
        add_library(${TARGET} SHARED ${AST_SOURCES} ${EXTRA_SOURCES})
    else()
        add_executable(${TARGET} ${AST_SOURCES} ${EXTRA_SOURCES})
    endif()
    target_compile_definitions(${TARGET} PRIVATE HAVE_BUILD_CONFIG)
    SDL_AddCommonCompilerFlags(${TARGET})
    target_include_directories(${TARGET} PRIVATE "${SDL3_SOURCE_DIR}/src/video/khronos")
    target_link_libraries(${TARGET} PRIVATE SDL3::SDL3_test SDL3::${sdl_name_component})
    if(NOT AST_NO_C90 AND NOT SDL_CMAKE_PLATFORM MATCHES "^(n3ds|ps2|psp)$")
        set_property(TARGET ${TARGET} PROPERTY C_STANDARD 90)
        set_property(TARGET ${TARGET} PROPERTY C_EXTENSIONS FALSE)
    endif()
    if(AST_DEPENDS)
        add_dependencies(${TARGET} ${AST_DEPENDS})
    endif()

    list(APPEND SDL_TEST_EXECUTABLES ${TARGET})
    set_property(TARGET ${TARGET} PROPERTY SDL_NOTRACKMEM ${AST_NOTRACKMEM})
    if(AST_NONINTERACTIVE)
        set_property(TARGET ${TARGET} PROPERTY SDL_NONINTERACTIVE 1)
    endif()
    set_property(TARGET ${TARGET} PROPERTY SDL_DISABLE_THREADS_ARGS "${AST_DISABLE_THREADS_ARGS}")
    set_property(TARGET ${TARGET} PROPERTY SDL_THREADS "${AST_THREADS}")
    if(AST_NONINTERACTIVE_ARGS)
        set_property(TARGET ${TARGET} PROPERTY SDL_NONINTERACTIVE_ARGUMENTS "${AST_NONINTERACTIVE_ARGS}")
    endif()
    if(AST_INSTALLED_ARGS)
        set_property(TARGET ${TARGET} PROPERTY SDL_INSTALLED_ARGUMENTS "${AST_INSTALLED_ARGS}")
    elseif(AST_NONINTERACTIVE_ARGS)
        set_property(TARGET ${TARGET} PROPERTY SDL_INSTALLED_ARGUMENTS "${AST_NONINTERACTIVE_ARGS}")
    endif()
    if(AST_NONINTERACTIVE_TIMEOUT)
        set_property(TARGET ${TARGET} PROPERTY SDL_NONINTERACTIVE_TIMEOUT "${AST_NONINTERACTIVE_TIMEOUT}")
    endif()
    if(AST_NEEDS_RESOURCES)
        if(PSP OR PS2 OR N3DS)
            add_custom_command(TARGET ${TARGET} POST_BUILD
                COMMAND ${CMAKE_COMMAND} ARGS -E make_directory $<TARGET_FILE_DIR:${TARGET}>/sdl-${TARGET}
                COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different ${RESOURCE_FILES} $<TARGET_FILE_DIR:${TARGET}>/sdl-${TARGET})
        else()
            add_dependencies(${TARGET} copy-sdl-test-resources)
        endif()
        if(APPLE)
            # Make sure resource files get installed into macOS/iOS .app bundles.
            set_target_properties(${TARGET} PROPERTIES RESOURCE "${RESOURCE_FILES}")
        endif()
        if(EMSCRIPTEN)
            foreach(res IN LISTS RESOURCE_FILES)
                get_filename_component(res_name "${res}" NAME)
                target_link_options(${TARGET} PRIVATE "SHELL:--embed-file ${res}@${res_name}")
                set_property(TARGET ${TARGET} APPEND PROPERTY LINK_DEPENDS "${res}")
            endforeach()
        endif()
        set_property(TARGET ${TARGET} APPEND PROPERTY ADDITIONAL_CLEAN_FILES "$<TARGET_FILE_DIR:${TARGET}>/$<JOIN:${RESOURCE_FILE_NAMES},$<SEMICOLON>$<TARGET_FILE_DIR:${TARGET}>/>")
    endif()
    if(AST_BUILD_DEPENDENT)
        target_include_directories(${TARGET} BEFORE PRIVATE $<TARGET_PROPERTY:SDL3::${sdl_name_component},INCLUDE_DIRECTORIES>)
        target_include_directories(${TARGET} BEFORE PRIVATE ${SDL3_SOURCE_DIR}/src)
        if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.20")
            target_include_directories(${TARGET} AFTER PRIVATE "${SDL3_SOURCE_DIR}/include/build_config")
        endif()
    endif()

    if(WINDOWS)
        # CET support was added in VS 16.7
        if(MSVC_VERSION GREATER 1926 AND CMAKE_GENERATOR_PLATFORM MATCHES "Win32|x64")
            set_property(TARGET ${TARGET} APPEND_STRING PROPERTY LINK_FLAGS " -CETCOMPAT")
        endif()
    elseif(PSP)
        target_link_libraries(${TARGET} PRIVATE GL)
    elseif(EMSCRIPTEN)
        set_property(TARGET ${TARGET} PROPERTY SUFFIX ".html")
        target_link_options(${TARGET} PRIVATE "SHELL:--pre-js ${CMAKE_CURRENT_SOURCE_DIR}/emscripten/pre.js")
        target_link_options(${TARGET} PRIVATE "-sEXIT_RUNTIME=1")
        set_property(TARGET ${TARGET} APPEND PROPERTY LINK_DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/emscripten/pre.js")
    endif()

    if(OPENGL_FOUND)
        target_compile_definitions(${TARGET} PRIVATE HAVE_OPENGL)
    endif()

    # FIXME: only add "${SDL3_BINARY_DIR}/include-config-$<LOWER_CASE:$<CONFIG>>" + include paths of external dependencies
    target_include_directories(${TARGET} PRIVATE "$<TARGET_PROPERTY:SDL3::${sdl_name_component},INCLUDE_DIRECTORIES>")
endmacro()

check_include_file(signal.h HAVE_SIGNAL_H)
if(HAVE_SIGNAL_H)
    add_definitions(-DHAVE_SIGNAL_H)
endif()

check_include_file(libudev.h HAVE_LIBUDEV_H)
if(HAVE_LIBUDEV_H)
    add_definitions(-DHAVE_LIBUDEV_H)
endif()

function(files2headers OUTPUT)
    set(xxd "${SDL3_SOURCE_DIR}/cmake/xxd.py")
    set(inputs ${ARGN})
    set(outputs )
    foreach(input IN LISTS inputs)
        get_filename_component(file_we "${input}" NAME_WE)
        set(intermediate "${CMAKE_CURRENT_BINARY_DIR}/${file_we}.h")
        set(output "${CMAKE_CURRENT_SOURCE_DIR}/${file_we}.h")
        list(APPEND outputs "${output}")
        if(TARGET Python3::Interpreter AND NOT CMAKE_CROSSCOMPILING)
            list(APPEND outputs  "${intermediate}")
            # Don't add the 'output' header to the output, to avoid marking them as GENERATED
            # (generated files are removed when running the CLEAN target)
            add_custom_command(OUTPUT "${intermediate}"
                COMMAND Python3::Interpreter "${xxd}" -i "${CMAKE_CURRENT_SOURCE_DIR}/${input}" "-o" "${intermediate}"
                COMMAND "${CMAKE_COMMAND}" -E copy_if_different "${intermediate}" "${output}"
                DEPENDS "${xxd}" "${bmp}"
            )
        endif()
    endforeach()
    set(${OUTPUT} "${outputs}" PARENT_SCOPE)
    add_custom_target(generate-${OUTPUT} DEPENDS ${outputs})
endfunction()

files2headers(gamepad_image_headers
    gamepad_axis_arrow.bmp
    gamepad_axis.bmp
    gamepad_back.bmp
    gamepad_battery.bmp
    gamepad_battery_wired.bmp
    gamepad_button_background.bmp
    gamepad_button.bmp
    gamepad_button_small.bmp
    gamepad_face_abxy.bmp
    gamepad_face_bayx.bmp
    gamepad_face_sony.bmp
    gamepad_front.bmp
    gamepad_touchpad.bmp
    gamepad_wired.bmp
    gamepad_wireless.bmp
)
files2headers(icon_bmp_header icon.bmp)
files2headers(glass_bmp_header glass.bmp)

set(FFmpeg_FIND_COMPONENTS AVCODEC AVFORMAT AVUTIL SWSCALE)
include("${CMAKE_CURRENT_LIST_DIR}/../cmake/FindFFmpeg.cmake")
if(FFmpeg_FOUND)
    cmake_push_check_state()
    list(APPEND CMAKE_REQUIRED_INCLUDES "${FFmpeg_AVUTIL_INCLUDE_DIRS}")
    list(APPEND CMAKE_REQUIRED_INCLUDES "${SDL3_SOURCE_DIR}/src/video/khronos")
    check_struct_has_member("AVFrame" "ch_layout" "libavutil/frame.h" LIBAVUTIL_AVFRAME_HAS_CH_LAYOUT)
    check_struct_has_member("AVVulkanFramesContext" "format" "libavutil/hwcontext_vulkan.h" LIBAVUTIL_AVFULKANFRAMESCONTEXT_HAS_FORMAT)
    cmake_pop_check_state()
endif()
if(FFmpeg_FOUND AND LIBAVUTIL_AVFRAME_HAS_CH_LAYOUT)
    add_sdl_test_executable(testffmpeg NO_C90 SOURCES testffmpeg.c testffmpeg_vulkan.c ${icon_bmp_header} DEPENDS generate-icon_bmp_header)
    if(LIBAVUTIL_AVFULKANFRAMESCONTEXT_HAS_FORMAT)
      target_compile_definitions(testffmpeg PRIVATE FFMPEG_VULKAN_SUPPORT)
    endif()
    if(APPLE)
        target_link_options(testffmpeg PRIVATE "-Wl,-framework,CoreVideo")
    endif()
    if(TARGET OpenGL::EGL)
